<script setup>
import { onUpdated, ref, computed, onUnmounted } from 'vue';
import { elmId } from '../itemsBase';
import { centerX } from './popups.js';

const WARN_MSG = 'This action is not reversible. Continue?';

const emits = defineEmits(['confirmed']);

const elRef = ref();
const item = ref(null);
let cb = null;
const nowarn = ref(false);


onUpdated(() => {
	if (item.value) { centerX(elRef.value); }

});

onUnmounted(() => {
	cb = null;
	item.value = null;
});

const msg = computed(() => {
	if (typeof item.value === 'string') return WARN_MSG;
	return item.value.warnMsg || WARN_MSG;
});

/// function provided to parent.
const show = (it, cb = null) => {
	item.value = it;
	cb = cb;
	nowarn.value = false;
}
const confirm = () => {

	const it = item.value;
	const f = cb;
	const localNoWarn = nowarn.value;

	item.value = null;
	cb = null;
	nowarn.value = false;

	if (it) emits('confirmed', it, localNoWarn);
	if (f) f();

}
const cancel = () => {
	cb = null;
	nowarn.value = false;
	item.value = null;
}
</script>

<template>
	<div class="popup" v-if="item" ref="elRef">

		<div v-if="typeof item === 'string'">
			<div>{{ item }}</div>
			<div>{{ msg }}</div>
		</div>
		<div v-else>
		<div class="log-title">{{ item.name.toString().toTitleCase() }}</div>
		<div>{{ item.desc }}</div>
		<div>{{ msg }}</div>
		<div class="skip"><label :for="elmId('nowarn')">Skip Warning</label>
		<input type="checkbox" v-model="nowarn" :id="elmId('nowarn')"></div>
		</div>

		<div>
		<button @click="confirm">Confirm</button>
		<button @click="cancel">Cancel</button>
		</div>

	</div>
</template>

<style scoped>
div.skip {
	margin-top: 1em;
	font-size: 0.9em;
}

div.popup div {
	margin: var(--sm-gap) 0;
}
</style>